#	$Id: Makefile.inc,v 1.8 1996/09/13 01:35:32 wpaul Exp wpaul $

# nis+ database backend sources

# RPCDIR= ${.DESTDIR}/usr/include/rpcsvc
# RPCDIR= ${.CURDIR}/../include/rpcsvc
.PATH: ${.CURDIR} ${RPCDIR}

# Internal database routines
SRCS+=		nis_db_struct_xdr.c nis_db_encode.c \
		nis_db_handle_manager.c nis_db_file_manager.c \
		nis_db_relation_cache.c

# Publically accessible routines
SRCS+=		nis_db_add_entry.c nis_db_checkpoint.c nis_db_create_table.c \
		nis_db_destroy_table.c nis_db_first_entry.c \
		nis_db_next_entry.c nis_db_free_result.c nis_db_initialize.c \
		nis_db_list_entries.c nis_db_remove_entry.c \
		nis_db_reset_next_entry.c nis_db_standby.c \
		nis_db_table_exists.c nis_db_unload_table.c

CLEANFILES+= nis.h nis_db_struct_xdr.c nis_db_struct.h

RPCGEN= rpcgen -C

#nis.h: nis.x nis_object.x nis_callback.x
#	${RPCGEN} -h -o ${.TARGET} ${RPCDIR}/nis.x

nis_db_struct.h: nis_db_struct.x
	${RPCGEN} -h -o ${.TARGET} ${.CURDIR}/nis_db_struct.x

nis_db_struct_xdr.c: nis_db_struct.h
	${RPCGEN} -c -o ${.TARGET} ${.CURDIR}/nis_db_struct.x

# Man pages
MAN3+=		nis_db.3
MLINKS+=	nis_db_3 db_add_entry.3 \
		nis_db.3 db_checkpoint.3 \
		nis_db.3 db_create_table.3 \
		nid_db.3 db_destroy_table.3 \
		nis_db.3 db_first_entry.3 \
		nis_db.3 db_free_result.3 \
		nis_db.3 db_initialize.3 \
		nis_db.3 db_list_entries.3 \
		nis_db.3 db_next_entry.3 \
		nis_db.3 db_remove_entry.3 \
		nis_db.3 db_reset_next_entry.3 \
		nis_db.3 db_standby.3 \
		nis_db.3 db_table_exists.3 \
		nis_db.3 db_unload_table.3

