#	$Id: Makefile.inc,v 1.8 1996/09/13 01:35:32 wpaul Exp $

# nis+ client library sources

MAN3+=	nis_names.3

# RPCDIR= ${.DESTDIR}/usr/include/rpcsvc
# RPCDIR= ${.CURDIR}/../include/rpcsvc
.PATH: ${.CURDIR} ${RPCDIR}

# NIS+ XDR routines -- should be in librpcsvc
SRCS+=		nis_xdr.c nis_callback_xdr.c nis_cache_xdr.c \
		nis_cache_bind_xdr.c

# NIS+ rpc auto-generated routines
SRCS+=		nis_clnt.c nis_callback_svc.c nis_cache_clnt.c \

# Publically accessible routines
SRCS+=		nislib_admin.c nislib_subr.c nislib_local_names.c \
		nislib_util.c nislib_names.c nislib_tables.c \
		nislib_error.c nislib_groups.c nislib_server.c

# Private routines used internally by the library
SRCS+=		nislib_callback.c nislib_bind.c nislib_ping.c \
		nislib_core.c nislib_stub.c nislib_cache_bind.c

# Hack
#SRCS+=		get_myaddress.c auth_time.c svc.c \
#		clnt_udp.c

CLEANFILES+=	nis_xdr.c nis.h nis_callback.h nis_cache_xdr.c \
		nis_callback_svc.c nis_callback_xdr.c \
		nis_clnt.c nis_cache_clnt.c nis_cache.h \
		nis_cache_bind_xdr.c nis_cache_bind.h

RPCGEN= rpcgen -C

nis.h: nis.x nis_object.x nis_callback.x
	${RPCGEN} -h -o ${.TARGET} ${RPCDIR}/nis.x

nis_cache.h: nis_cache.x
	${RPCGEN} -h -o ${.TARGET} ${RPCDIR}/nis_cache.x

nis_cache_bind.h: nis_cache_bind.x
	${RPCGEN} -h -o ${.TARGET} ${RPCDIR}/nis_cache_bind.x

nis_xdr.c: nis.h
	${RPCGEN} -c -o ${.TARGET} ${RPCDIR}/nis.x

nis_clnt.c: nis.h
	${RPCGEN} -l -o ${.TARGET} ${RPCDIR}/nis.x

nis_cache_clnt.c: nis_cache.h
	${RPCGEN} -l -o ${.TARGET} ${RPCDIR}/nis_cache.x

nis_cache_xdr.c: nis_cache.h
	${RPCGEN} -c -o ${.TARGET} ${RPCDIR}/nis_cache.x

nis_cache_bind_xdr.c: nis_cache_bind.h
	${RPCGEN} -c -o ${.TARGET} ${RPCDIR}/nis_cache_bind.x

nis_callback.h: nis_callback.x
	${RPCGEN} -h -o ${.TARGET} ${RPCDIR}/nis_callback.x

nis_callback_xdr.c: nis_callback.h
	${RPCGEN} -c -o ${.TARGET} ${RPCDIR}/nis_callback.x

nis_callback_svc.c: nis_callback.h
	${RPCGEN} -m -o ${.TARGET} ${RPCDIR}/nis_callback.x
