/*
 * Copyright (c) 1996
 *	Bill Paul <wpaul@ctr.columbia.edu>.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by Bill Paul.
 * 4. Neither the name of the author nor the names of any co-contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY Bill Paul AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL Bill Paul OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	$Id: nislib_private.h,v 1.1 1998/07/08 19:16:49 wpaul Exp wpaul $
 */

#ifndef _PATH_NIS_COLD_START
#define _PATH_NIS_COLD_START "/var/nis/NIS_COLD_START"
#endif

#include <rpc/rpc.h>
#include <rpc/key_prot.h>
#include <rpcsvc/nis.h>
#include <rpcsvc/nislib.h>
#include <rpcsvc/nis_tags.h>
/*
#include "/proj/mbone/nis/lib/dbmalloc/malloc.h"
*/

struct nis_callback {
	nis_server		*clnt_uaddr;
	SVCXPRT			*xprt;
	int			sock;
	int			nomore;
	nis_error		err;
	int (*callback)(nis_name, nis_object *, void *);
	void			*userdata;
};

#ifndef NIS_CLIENT_TIMEOUT
#define NIS_CLIENT_TIMEOUT 10
#endif

#ifndef NIS_WINDOW
#define NIS_WINDOW 300
#endif

#define SEARCHOP_LIST	1
#define SEARCHOP_LOOKUP	2

#define NIS_FREEDIR(x)				\
	xdr_free((xdrproc_t)xdr_directory_obj, (char *)x);	\
	free(x);

#define NIS_FREESRV(x)				\
	xdr_free((xdrproc_t)xdr_nis_server, (char *)x);	\
	free(x);

extern nis_result *__nis_search __P (( nis_name, uint32_t, uint32_t, nis_attr *, uint32_t, int (*)(nis_name, nis_object *, void *) , void * ));
extern nis_result *__nis_search_core __P (( nis_name, uint32_t, uint32_t, nis_attr *, uint32_t, int (*)(nis_name, nis_object *, void *) , void * ));

extern nis_error __nis_ping __P(( struct _nis_binding * ));

extern nis_error __nis_parse_request __P(( nis_name, nis_attr **,
					uint32_t *, nis_name * ));

extern struct nis_callback *__nis_create_callback __P(( struct _nis_binding *,
			int (*)(nis_name, nis_object *, void *), void *));
extern nis_error __nis_do_callback __P(( struct _nis_binding *, netobj *,
						struct nis_callback * ));
extern nis_error __nis_destroy_callback __P(( struct nis_callback * ));

extern void __nis_destroy_cache_binding __P(( struct _nis_binding * ));

