#include <sys/types.h>
#include <sys/mman.h>
#include <sys/fcntl.h>
#include <sys/stat.h>

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

void my_waitforlock(fd, pid)
	int			fd, pid;
{
	struct flock		lock;

	lock.l_start = 0;
	lock.l_len = 0;
	lock.l_pid = pid;
	lock.l_type = F_WRLCK;
	lock.l_whence = SEEK_SET;

	if (fcntl(fd, F_SETLKW, &lock) == -1)
		err(1, "unlock(%d)", pid);

	return;
}

void my_unlock(fd, pid)
	int			fd, pid;
{
	struct flock		lock;

	lock.l_start = 0;
	lock.l_len = 0;
	lock.l_pid = pid;
	lock.l_type = F_UNLCK;
	lock.l_whence = SEEK_SET;

	if (fcntl(fd, F_SETLKW, &lock) == -1)
		err(1, "unlock(%d)", pid);

	return;
}

main()
{
	int			i, fd, zero, *ptr;
	int			pid;

	zero = 0;
	unlink("mtest.map");
	fd = open("mtest.map", O_RDWR|O_CREAT, S_IRUSR|S_IWUSR);
	write(fd, &zero, sizeof(int));
	ptr = mmap(NULL, sizeof(int), PROT_READ|PROT_WRITE, MAP_SHARED, fd, 0);

	setbuf(stdout, NULL);
	if (fork() == 0) {
		pid = getpid();
		for (i = 0; i < 100; i++) {
			my_waitforlock(fd, pid);
			printf("child: %d\n", (*ptr)++);
			my_unlock(fd, pid);
		}
		exit(0);
	} else {
		pid = getpid();
		for (i = 0; i < 100; i++) {
			my_waitforlock(fd, pid);
			printf("parent: %d\n", (*ptr)++);
			my_unlock(fd, pid);
		}
		exit(0);
	}
}
