/*
 * Copyright (c) 1996, 1997, 1998
 *	Bill Paul <wpaul@ctr.columbia.edu>.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by Bill Paul.
 * 4. Neither the name of the author nor the names of any co-contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY Bill Paul AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL Bill Paul OR THE VOICES IN HIS HEAD
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 *
 *	$Id$
 */

#ifndef RPC_HDR
%#ifndef lint
%static const char rcsid[] = "@(#) $Id$";
%#endif
#endif

#ifdef RPC_HDR
%#include <rpcsvc/nis.h>
#endif

const CB_CHUNKSIZE		= 8192;
const CB_HEADER_MAGIC		= 987654321;
const CB_VERSION		= 2;

enum cb_type {
	CB_MASTER		= 0,
	CB_REPLICA		= 1,
	CB_SERVER		= 2
};

struct cachebind_hash_entry {
	unsigned long			hval;
	unsigned long			cb_type;
	nis_name			name;
	nis_bound_endpoint		*bep_ptr;
	nis_bound_directory		*bdr_ptr;
	nis_active_endpoint		*aep_ptr;
	unsigned long			cr_time;
	struct cachebind_hash_entry	*next;
};

const TABLESIZE		= 256;
const HASH_MASK		= 0x000000FF;

typedef cachebind_hash_entry *cachebind_hash_entry_p;
/*
typedef cachebind_hash_entry_p cachebind_hash_table[TABLESIZE];
*/
enum cb_state {
	CB_UPDATING		= 0,
	CB_LOCKED		= 1,
	CB_UNLOCKED		= 2,
	CB_BINDING		= 3,
	CB_STABLE		= 4
};

struct cachebind_header {
	unsigned long		cb_magic;
	unsigned long		cb_vers;
	cb_state		cb_state;
	unsigned long		cb_generation;
	unsigned long		cb_starttime;
	unsigned long		cb_updatetime;
};

struct cachebind_combined {
	cachebind_header	cachebind_header;
	cachebind_hash_entry_p	cachebind_hash_table[TABLESIZE];
};
