/*
 * Copyright (c) 1996, 1997
 *	Bill Paul <wpaul@ctr.columbia.edu>.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by Bill Paul.
 * 4. Neither the name of the author nor the names of any co-contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY Bill Paul AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL Bill Paul OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	$Id: nis_cache_extern.h,v 1.4 1997/06/16 23:49:10 wpaul Exp wpaul $
 */

#ifndef lint
static const char rcsid_nis_cache_extern_h[] =
	"@(#) $Id: nis_cache_extern.h,v 1.4 1997/06/16 23:49:10 wpaul Exp wpaul $";
#endif

#include "nis_cache_bind.h"

extern void cacheprog_2 __P(( struct svc_req *, register SVCXPRT * ));
extern int insecure;
extern int debug;
extern void nis_cache_pkeys __P(( directory_obj * ));
extern void nis_remove_pkeys __P(( directory_obj * ));
extern char *nis_lookup_pkey __P(( nis_name ));

extern int nis_cache_refresh __P(( directory_obj * ));
extern int nis_cache_add __P(( directory_obj * ));
extern int nis_cache_remove __P(( nis_name ));
extern int nis_cache_load __P (( void ));
extern int nis_cache_dump __P (( void ));
extern int nis_cache_open __P (( void ));
extern void nis_cache_init __P (( void ));
extern int nis_verify_sig __P (( fd_result *));
extern nis_error nis_get_cold_start __P(( directory_obj ** ));

extern void nis_lock_cache __P (( void ));
extern void nis_unlock_cache __P(( void ));

extern nis_error nis_cachebind_close __P(( void ));
extern nis_error nis_cachebind_delete __P(( nis_name, cb_type ));
extern nis_error nis_cachebind_insert __P(( nis_name, cb_type ,
						nis_bound_endpoint * ,
						nis_bound_directory * ,
						nis_active_endpoint * ));
extern cachebind_hash_entry *nis_cachebind_lookup __P(( nis_name, cb_type ));
extern nis_error nis_cachebind_open __P(( char * ));
